// #autoload
// #name = Waypoint anything
// #version = 1.0.1
// #date = 2004-05-22
// #author = Ben Winslow
// #warrior = Raineth
// #description = Allows waypointing of just about anything on the map
// #status = stable
// #readme = scripts/autoexec/rain/txt/waypointany.txt
// #category = Rain's scripts

package waypointAny {
	function GuiCommanderMap::buildPopupCommands(%this, %taskType, %sensorGroup)
	{
		// add normal entries first
		parent::buildPopupCommands(%this, %taskType, %sensorGroup);
		
		// allow the attachment of a waypoint to anything so long as it's
		// not a waypoint itself (kinda pointless) and it's not terrain
		// (which has its own waypoint option)
		switch$ (getTaggedString(%taskType)) {
			case "Location":
				return;
			case "Waypoint":
				return;
			case "PotentialTask":
				return;
			case "AssignedTask":
				return;
		}
		CMContextPopup.addEntry("w", "\c1W\craypoint object", 'WaypointObject');
	}
	
	function CommanderTree::processCommand(%this, %command, %target, %typeTag)
	{
		// is this ours?
		if (getTaggedString(%command) $= "WaypointObject") {
			// paranoia
			if (%objName < 0 || %objType < 0)
				return;
			
			// hackish, but I can't change the proto here :/
			%objName = getTaggedString(CMContextPopup.nameTag);
			%objType = getTaggedString(%typeTag);
			
//			echo("\c1WaypointObject\cr: add" SPC
//				%objName SPC "(" @ CMContextPopup.nameTag @ ")" SPC
//				%objType SPC "(" @ %typeTag @ ")");

			// don't add type for clients
			if (%objType $= "_ClientConnection")
				%name = %objName;
			else
				%name = %objName SPC %objType;
		
			%target.createWaypoint(%name);
			// I'd love to indicate health here, but I can't figure out how
			// (even approximate as in the commander map list would be nice)
//			%target.setText("newname");
		
			%id = %target.getTargetId();

			if (%id != -1) {
				$ClientWaypoints.add(%target);
				CMContextPopup.target = -1;
			}
			return;
		}
		
		// not ours, try the other types
		return parent::processCommand(%this, %command, %target, %typeTag);
	}
};

activatePackage(waypointAny);
